package ovh.mxg.mxcrafttp;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.sql.*;
import java.text.MessageFormat;

public class SQL {
    public static Connection con;

    static ConsoleCommandSender console = Bukkit.getConsoleSender();

    // connect
    public static void connect() {
        if (!isConnected()) {
            try {
                con = DriverManager.getConnection("jdbc:mysql://" + MxCraftTP.host + ":" + MxCraftTP.port + "/" + MxCraftTP.database, MxCraftTP.username, MxCraftTP.password);
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    // disconnect
    public static void disconnect() {
        if (isConnected()) {
            try {
                con.close();
                console.sendMessage("\247c[\2476Minepedia-System\247c]\247bMySQL-Verbindung wurde geschlossen!");
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    // isConnected
    public static boolean isConnected() {
        return (con == null ? false : true);
    }

    // getConnection
    public static Connection getConnection() {
        return con;
    }

    public static void AddCube(String name, double x, double y, double z) throws SQLException {
        connect();
        PreparedStatement ps = getConnection().prepareStatement("INSERT IGNORE INTO cubetp (name,x,y,z) VALUES (?,?,?,?)");
        ps.setString(1, name);
        ps.setDouble(2, x);
        ps.setDouble(3, y);
        ps.setDouble(4, z);
        ps.executeUpdate();
    }

    public static boolean CheckCubeNameExists(String name) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubetp WHERE name = ?");
        ps.setString(1, name);
        ResultSet rs = ps.executeQuery();
        return rs.next();
    }

    public static void DeleteCubeByName(String name) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("DELETE FROM cubetp WHERE name = ?");
        ps.setString(1, name);
        ps.executeUpdate();
    }

    public static boolean CheckCubeByLocation(double x, double y, double z) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubetp WHERE x = ? AND y = ? AND z = ?");
        ps.setDouble(1, x);
        ps.setDouble(2, y);
        ps.setDouble(3, z);
        ResultSet rs = ps.executeQuery();
        return rs.next();
    }

    public static String GetCubeNameByLocation(double x, double y, double z) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubetp WHERE x = ? AND y = ? AND z = ?");
        ps.setDouble(1, x);
        ps.setDouble(2, y);
        ps.setDouble(3, z);
        ResultSet rs = ps.executeQuery();
        if(rs.next()){
            return rs.getString("name");
        }
        return null;
    }
}
